; Simple-minded demonstration of arithmetic.  File:  newarith.lisp
; For CM-5

(in-package '*lisp)

(*PROCLAIM '(TYPE SINGLE-FLOAT-PVAR S X Y Z U V W))

(*DEFVAR X (-!! (random!! (!! 10.0)) (!! 5.0)))
(*DEFVAR Y (-!! (random!! (!! 10.0)) (!! 5.0)))
(*DEFVAR Z (-!! (random!! (!! 10.0)) (!! 5.0)))
(*DEFVAR U (-!! (random!! (!! 10.0)) (!! 5.0)))
(*DEFVAR V (-!! (random!! (!! 10.0)) (!! 5.0)))
(*DEFVAR W (-!! (random!! (!! 10.0)) (!! 5.0)))

(*DEFVAR S (!! 0.0))

(defvar vprcs 0)    ;; Set to number of virtual processors
(defvar flops 0)    ;; Set to number of fl operations in test

; Sets up arithmetic demo.  Start in *Lisp package
(defun start (xs ys)
 (*cold-boot :initial-dimensions (list xs ys))
 (setq vprcs (* xs ys))
 (format t "~D virtual processors~%" vprcs)
 (demo 10)
)

(defun demo (n)
"(demo n) -- times n cycles of S := X*U + Y*V + Z*W + X*V + Y*V"
  (cm:time (demox n))
  (setq flops (* vprcs 10 n))
)

(defun demox (n)
  (declare (type fixnum n))
  (dotimes (k n)
    (*set S (+!! S (*!! X U) (*!! Y V) (*!! Z W) (*!! X V) (*!! Y V))))
)

(*PROCLAIM '(type (vector-pvar single-float 20) XV))

(*DEFVAR XV (make-array!! '(20) :element-type 'single-float
                                :initial-element 3.14159))

;; Similar timing for vector operations

(defun vdemo (n)
"(vdemo n) -- times n cycles of 20-word vector-abs-squared"
 (cm:time (vdemox n))
 (setq flops (* vprcs 39 n))
)

(defun vdemox (n)
  (declare (type fixnum n))
  (dotimes (k n) (*set S (vabs-squared!! XV)))
)


